local log,log0 in gui.BattleLog

local end_sides_turn, is_tracking_object, current_sides_objects in _G



local mod_max_tracker_time



local function end_turn_healing()

	-- for the end turn healing, we'd like to add an empty
	-- animation so that any health changes will be animated.  
	-- however, we only want such an animation if some healing has
	-- actually happened.
	--local state0=pre_attack_state()
	local end_delay=current_event_end_time()

	local needs_ani

	advance_animation_time( end_delay )
	local death_delay=.5
	local object_deltas,delta_ani = animate_deltas(death_delay,|) function()

		for object in current_sides_objects() do

			if is_ship(object) 

				needs_ani = heal_emp(object) or needs_ani
				needs_ani = shield_regen(object) or needs_ani
				needs_ani = apply_autorepair(object) or needs_ani

				-- clear any unused overcharge perks
				for w in weapons(object)
					w.overcharge_damage=nil
				end
				object.has_used_capacitor=nil

			end
		end
	end



	if(needs_ani)
	
		local ani = append_animation(end_delay,{
			tn=.5,
			request=function() end,
		})

		local object_changes = object_table_form(object_deltas)

		SCOPE_call(..death_delay,
				animated_damage_text, object_changes,  delta_ani)

	end

end

function end_turn()
	


  --print('calling end turn with',..current_side())

	-- do the final tracking updates
	-- we only move trackers that have moved less than the standard
	-- move time
	local total_move_time in motion_function

	--sprint(total_move_time)

	local current=current_side()

	local moving_trackers={}

	for object in objects() do



		if( is_tracking_object(object) )
			
			if( current==object.dest.empire )

				if(object.dest.launch_time_gift or object.dest.time_spent_moving<.9*total_move_time)
					object.time_spent_moving=0
					object.max_t=
						object.dest.launch_time_gift or
						(total_move_time-object.dest.time_spent_moving)
			
					--sprint(object.dest.launch_time_gift )

					moving_trackers[#moving_trackers+1]=object
			
				end 
			else
				if( object.max_t~=max_double)
					object.max_t=max_double
				end
				object.time_spent_moving=0
			end

		end

	end


	move_trackers()

	for object in objects() do
		object.launch_time_gift=nil
	end

	-- rest the time variables for all the trackers that just moved
	for i,object in ipairs(moving_trackers) do

		if(is_tracking_object(object) )
			--sprint(object.time_spent_moving)
			object.time_spent_moving=0
			
			if object.tracker_type~="fighter" 
				object.attacks_this_turn=0
			end
		end
	end
	
  local end_ani = append_animation {
    request = function(t) 
      --print('end turn ani') 
    end,
    on_scheduled = function(ani_t)
    end,
    tn=.2,
    exclusive_animation=true,
  }

	end_turn_healing()

  --print('about to switch to next side',..current_side())
	end_sides_turn()
  --print('switched to new side',..current_side())


	for object in current_sides_objects() do
		object.time_spent_moving=0
		
		if( is_ship(object) )
		
			local Siyoa_aft_shields=object["aft_shields"]
			local Siyoa_fore_shields=object["fore_shields"]
			local Siyoa_starboard_shields=object["starboard_shields"]
			local Siyoa_port_shields=object["port_shields"]

			if object.never_rotates then
				object["port_shields"]=Siyoa_fore_shields
				object["aft_shields"]=Siyoa_port_shields
				object["starboard_shields"]=Siyoa_aft_shields
				object["fore_shields"]=Siyoa_starboard_shields
			end
		
			-- restore fuel
      if object.empire
			  object.fuel=object.max_fuel
      end

      object.fired_any_weapons=nil
      object.cloaked_this_turn=nil
			object.discharged_electrocyte=nil

			-- reset fired
      if not object.cloaked
			  for w in weapons(object) do
				  local winfo = WEAPONS[w.parent_type]

				  -- missiles are only reset if the ship still has munitions
				  if w.needs_munitions

					  local tn,d=w:remaining()

					  if object.munitions>0
						  w.fired=0
					  else
						  w.fired=w.n
					  end

				  -- all other weapons (i.e., beams) always have fired reset 
				  else
					  w.fired=0
				  end
					

			  end
      end

			object.has_boarded=false

			if object.retreating

				if object.speed_class==0
					object.retreating=nil
				else

					object.retreating-=1


		
					if object.retreating<=0
						object.retreated=true
						object.dead=true


						local destruct_ani=inherit(drawers.warp_effect, {
							dying=object,
							on_create=_nullop
						})


						clear_death_position(object)
						add_death_animation( current_event_time(), destruct_ani)

          else
            object.fuel=0
					end

				end

				



			end

		end



	end





	--sprint(end_delay)



end

if lua_load_complete
  
  for ship in objects()
    print(ship,ship.inactive)
  end

end